#include "dpci8255.h"  
#include <sys/ioctl.h>  /* ioctl */


int WritePci8255Counter(int file_desc, int number,int value)
{
  int ret_val;
  if((number<COUNTER1)||(number>COUNTER3)) return -1;
  ret_val = ioctl(file_desc, DPCI8255_SET_REGISTER, number);
  ret_val = ioctl(file_desc, DPCI8255_WRITE_COUNTER, value);
  return ret_val;
}

int ReadPci8255Counter(int file_desc, int number)
{
  int ret_val=0;
  if((number<COUNTER1)||(number>COUNTER3)) return -1;
  ioctl(file_desc, DPCI8255_SET_REGISTER, number);
  ioctl(file_desc, DPCI8255_READ_COUNTER, &ret_val);
  return ret_val;
}

int WritePci8255Port(int file_desc, int port,char value)
{
  int ret_val;
  if((port<0)||(port>PORTC2)) return -1;
  ret_val = ioctl(file_desc, DPCI8255_SET_REGISTER, port);
  ret_val = ioctl(file_desc, DPCI8255_WRITE_PORT, value);
  return ret_val;
}

char ReadPci8255Port(int file_desc, int port)
{
  char ret_val=0;
  if((port<0)||(port>PORTC2)) return -1;
  ioctl(file_desc, DPCI8255_SET_REGISTER, port);
  ioctl(file_desc, DPCI8255_READ_PORT, &ret_val);
  return ret_val;
}

int WritePci8255ControlWord(int file_desc, int port, char value)
{
 int ret_val;
  ret_val = ioctl(file_desc, DPCI8255_SET_REGISTER, port);
  ret_val = ioctl(file_desc, DPCI8255_SET_CONTROLWORD, value);
  return ret_val;
}

char ReadPci8255ControlWord(int file_desc, int port)
{
  char ret_val=0;
  if((port<0)||(port>CONTROLWORD3)) return -1;
  ioctl(file_desc, DPCI8255_SET_REGISTER, port);
  ioctl(file_desc, DPCI8255_GET_CONTROLWORD, &ret_val);
  return(~ret_val);
}